#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h> /* close */


#define SUCCESS 0
#define ERROR   1

#define WELCOME "Welcome\n"

int poc_pripojeni=0;

void server(int s)
{
  char buf[100];
  int rcvLen;
  int err;

  poc_pripojeni++;
  printf("Spojeni Navazano! (pocet aktivnich pripojeni: %d)\n",poc_pripojeni);
  printf("Odesilam uvitaci hlaseni\n");
  send( s, WELCOME , strlen(WELCOME), 0);

  for (;;)
  {
    rcvLen=recv(s, buf, sizeof(buf)-1, 0);
    if (rcvLen>0)
    {
      buf[rcvLen]=0;
      printf("Prijato > %s", buf);

      strupr(buf);
	  printf("Odeslano> %s",buf);

	  err=send( s, buf, strlen(buf), 0);
    }
	else break;
  }
  poc_pripojeni--;
  printf("Spojeni ukonceno! (pocet aktivnich pripojeni: %d)\n",poc_pripojeni);
  err=close(s);
}


int main (int argc, char *argv[]) {
  
  int sd, newSd, cliLen;

  struct sockaddr_in cliAddr, servAddr;
  int port;

  printf("Zadej port, na kterem spustit server: ");
  scanf("%d",&port);


  /* vytvoreni socketu */
  sd = socket(AF_INET, SOCK_STREAM, 0);
   if(sd<0) {
    perror("Nelze otevrit socket ");
    return ERROR;
  }
  
  /* Bind */
  servAddr.sin_family = AF_INET;
  servAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  servAddr.sin_port = htons(port);
  
  if(bind(sd, (struct sockaddr *) &servAddr, sizeof(servAddr))<0) {
    perror("Chyba Bind ");
    return ERROR;
  }

  listen(sd,5);
  
  while(1) 
  {
    printf("Ceka se na pripojeni na portu %u\n",port);

    cliLen = sizeof(cliAddr);
    newSd = accept(sd, (struct sockaddr *) &cliAddr, &cliLen);
    if(newSd<0) {
	  perror("Chyba : Accept ");
      return ERROR;
	}
    if (fork()==0) 
	{
		server(newSd);
		return 0;
	}
  } 
}
